#ifndef OVAL_DEFINITIONS_IMPL
#define OVAL_DEFINITIONS_IMPL
#include <liboval/oval_definitions.h>

	OvalCollection_affected     newOvalCollection_affected    (Oval_affected*     affected_array);
	OvalCollection_test         newOvalCollection_test        (Oval_test*         test_array);
	OvalCollection_criteriaNode newOvalCollection_criteriaNode(Oval_criteriaNode* criteriaNode_array);
	OvalCollection_reference    newOvalCollection_reference   (Oval_reference*    reference_array);
	OvalCollection_definition   newOvalCollection_definition  (Oval_definition*   definition_array);

/*

	typedef void* Oval_object;
	typedef void* OvalCollection_object;

	typedef void* Oval_state;
	typedef void* OvalCollection_state;

	typedef void* Oval_variable;
	typedef void* OvalCollection_variable;

	typedef void* Oval_variableBinding;
	typedef void* OvalCollection_variableBinding;

	typedef void* Oval_objectContent;
	typedef void* OvalCollection_objectContent;

	typedef void* Oval_behavior;
	typedef void* OvalCollection_behavior;

	typedef void* Oval_entity;

	typedef void* OvalCollection_set;
	typedef void* Oval_set;

	typedef void* Oval_value;
	typedef void* OvalCollection_value;

	typedef void* Oval_component;
	typedef void* OvalCollection_component;

	int  OvalCollection_test_hasMore      (OvalCollection_test);
	Oval_test OvalCollection_test_next    (OvalCollection_test);

	int  OvalCollection_object_hasMore      (OvalCollection_object);
	Oval_object OvalCollection_object_next  (OvalCollection_object);

	Oval_family_enum Oval_object_family                   (Oval_object);
	Oval_subtype_enum Oval_object_subtype                 (Oval_object);
	char* Oval_object_name                                (Oval_object);
	OvalCollection_string Oval_object_notes               (Oval_object);
	char* Oval_object_comment                             (Oval_object);
	char* Oval_object_id                                  (Oval_object);
	int Oval_object_deprecated                            (Oval_object);
	int Oval_object_version                               (Oval_object);
	OvalCollection_objectContent Oval_object_objectContent(Oval_object);
	OvalCollection_behavior Oval_object_behaviors         (Oval_object);

	int  OvalCollection_variableBinding_hasMore              (OvalCollection_variableBinding);
	Oval_variableBinding OvalCollection_variableBinding_next (OvalCollection_variableBinding);

	Oval_variable Oval_variableBinding_variable (Oval_variableBinding);
	char* Oval_variableBinding_value            (Oval_variableBinding);

	int  OvalCollection_objectContent_hasMore             (OvalCollection_objectContent);
	Oval_objectContent OvalCollection_objectContent_next  (OvalCollection_objectContent);

	char* Oval_objectContent_fieldName                  (Oval_objectContent);
	Oval_objectContent_type_enum Oval_objectContent_type(Oval_objectContent);
	Oval_entity Oval_objectContent_entity               (Oval_objectContent);//type == OVAL_OBJECTCONTENT_ENTITY
	Oval_check_enum Oval_objectContent_varCheck         (Oval_objectContent);//type == OVAL_OBJECTCONTENT_ENTITY
	Oval_set Oval_objectContent_set                     (Oval_objectContent);//type == OVAL_OBJECTCONTENT_SET

	Oval_entity_type_enum Oval_entity_type              (Oval_entity);
	Oval_datatype_enum Oval_entity_datatype             (Oval_entity);
	Oval_operator_enum Oval_entity_operator             (Oval_entity);
	int Oval_entity_mask                                (Oval_entity);
	Oval_entity_varref_type_enum Oval_entity_varref_type(Oval_entity);
	Oval_variable Oval_entity_variable                  (Oval_entity);
	Oval_value Oval_entity_value                        (Oval_entity);

	int  OvalCollection_set_hasMore   (OvalCollection_set);
	Oval_set OvalCollection_set_next  (OvalCollection_set);

	Oval_set_type_enum Oval_set_type          (Oval_set);
	Oval_set_operation_enum Oval_set_operation(Oval_set);
	OvalCollection_set Oval_set_subsets       (Oval_set);//type==OVAL_SET_AGGREGATE;
	OvalCollection_object Oval_set_objects    (Oval_set);//type==OVAL_SET_COLLECTIVE;
	OvalCollection_state Oval_set_filters     (Oval_set);//type==OVAL_SET_COLLECTIVE;

	int  OvalCollection_behavior_hasMore        (OvalCollection_behavior);
	Oval_behavior OvalCollection_behavior_next  (OvalCollection_behavior);

	Oval_value Oval_behavior_value (Oval_behavior);
	OvalCollection_string Oval_behavior_attributeKeys (Oval_behavior);
	Oval_value Oval_behavior_value_forKey(Oval_behavior, char* attributeKey);

	int  OvalCollection_value_hasMore   (OvalCollection_value);
	Oval_value OvalCollection_value_next(OvalCollection_value);

	Oval_datatype_enum Oval_value_datatype(Oval_value);
	char* Oval_value_text                 (Oval_value);
	unsigned char* Oval_value_binary      (Oval_value);//datatype==OVAL_DATATYPE_BINARY
	char Oval_value_boolean               (Oval_value);//datatype==OVAL_DATATYPE_BOOLEAN
	float Oval_value_float                (Oval_value);//datatype==OVAL_DATATYPE_FLOAT
	long Oval_value_integer               (Oval_value);//datatype==OVAL_DATATYPE_INTEGER


	int  OvalCollection_state_hasMore      (OvalCollection_state);
	Oval_state OvalCollection_state_next   (OvalCollection_state);

	Oval_family_enum Oval_state_family    (Oval_state);
	Oval_subtype_enum Oval_state_subtype  (Oval_state);
	char* Oval_state_name                 (Oval_state);
	OvalCollection_string Oval_state_notes(Oval_state);
	char* Oval_state_comment              (Oval_state);
	char* Oval_state_id                   (Oval_state);
	int Oval_state_deprecated             (Oval_state);
	int Oval_state_version                (Oval_state);

	int  OvalCollection_variable_hasMore      (OvalCollection_variable);
	Oval_variable OvalCollection_variable_next(OvalCollection_variable);

	char* Oval_variable_Id                               (Oval_variable);
	Oval_variable_type_enum Oval_variable_type           (Oval_variable);
	Oval_datatype_enum Oval_variable_datatype            (Oval_variable);
	OvalCollection_value Oval_variable_values            (Oval_variable);//type==OVAL_VARIABLE_CONSTANT
	Oval_component Oval_variable_component               (Oval_variable);//type==OVAL_VARIABLE_LOCAL

	int  OvalCollection_component_hasMore       (OvalCollection_component);
	Oval_component OvalCollection_component_next(OvalCollection_component);

	Oval_component_type_enum Oval_component_type(Oval_component);
	Oval_value Oval_component_literalValue                     (Oval_component);//type==OVAL_COMPONENT_LITERAL
	Oval_object Oval_component_object                          (Oval_component);//type==OVAL_COMPONENT_OBJECTREF
	char* Oval_component_object_field                          (Oval_component);//type==OVAL_COMPONENT_OBJECTREF
	Oval_variable Oval_component_variable                      (Oval_component);//type==OVAL_COMPONENT_VARREF
	Oval_function_type_enum Oval_component_function_type       (Oval_component);//type==OVAL_COMPONENT_FUNCTION
	OvalCollection_component Oval_component_function_components(Oval_component);//type==OVAL_COMPONENT_FUNCTION
	OvalCollection_string Oval_component_function_keys         (Oval_component);           //type==OVAL_COMPONENT_FUNCTION
	Oval_value Oval_component_function_value                   (Oval_component, char* key);//type==OVAL_COMPONENT_FUNCTION
*/
#endif
